### Climate parameters dialog


proc climpar_close { } {
   global g

   destroy .climpar_dlg
   set g(climpar_showing) 0 }


proc climpar_ok { } {
   global g

   climpar_close
   set changed 0

   # Adjust rainfall cut
   if { [ string compare $g(climpar_new_rain) $g(climpar_rain) ] } {
      set g(climpar_rain) $g(climpar_new_rain)
      switch $g(climpar_rain) {
         low  { wbCut 1 40 60 80 100 120   0 }
         avg  { wbCut 1 20 40 60  75  90   0 }
         high { wbCut 1 10 20 30  70 100   0 } }
      set changed 1 }

   # Adjust temperature cut
   if { [ string compare $g(climpar_new_temp) $g(climpar_temp) ] } {
      set g(climpar_temp) $g(climpar_new_temp)
      switch $g(climpar_temp) {
         low  { wbCut 0  90  150 220 256 256  80 }
         avg  { wbCut 0  60  100 160 230 256  50 }
         high { wbCut 0  30   60 120 180 256  20 } }
      set changed 1 }

   # Adjust season
   if { $g(climpar_seasel) != $g(climpar_new_seasel) } {
      set g(climpar_seasel) $g(climpar_new_seasel)
      set changed 1
   }
   if { ! [ string compare $g(climpar_seasel) avg ] } {
      set season -1
   } else {
      if { $g(climpar_season) != $g(climpar_new_season) } {
         set g(climpar_season) $g(climpar_new_season)
         set changed 1
      }
      set season $g(climpar_season)
   }
   set g(climpar_season) $g(climpar_new_season)

   # Adjust interpolation
   if { $g(climpar_interpol) != $g(climpar_new_interpol) } {
      set changed 1
   }
   util_flags state_season $season climpar_interpol $g(climpar_new_interpol)
   
   # Redraw if parameters changed
   # Bug: if temp/rain displayed, and season changed, does not redraw
   if { $changed && $g(state_clim_valid) } {
      util_busy . on
      update idletasks
      wbClim
      util_flags state_have_rivers 0
      view_facet clim
      util_busy . off } }


proc clim_params { } {
   global g

   if { ! $g(climpar_showing) } {
      set g(climpar_showing)      1
      set g(climpar_new_rain)     $g(climpar_rain)
      set g(climpar_new_temp)     $g(climpar_temp)
      set g(climpar_new_seasel)   $g(climpar_seasel)
      set g(climpar_new_season)   $g(climpar_season)
      set g(climpar_new_interpol) $g(climpar_interpol)
      toplevel .climpar_dlg

      # Top level frame
      frame .climpar_dlg.top
      frame .climpar_dlg.btns
      grid .climpar_dlg.top -column 0 -row 0
      grid .climpar_dlg.btns -column 0 -row 1

      # Rainfall radio buttons
      label .climpar_dlg.top.rt -text "Rainfall:" -justify right
      frame .climpar_dlg.top.rf
      radiobutton .climpar_dlg.top.rf.rl -text "Low" \
         -variable g(climpar_new_rain) -value low
      radiobutton .climpar_dlg.top.rf.ra -text "Average" \
         -variable g(climpar_new_rain) -value avg
      radiobutton .climpar_dlg.top.rf.rh -text "High" \
         -variable g(climpar_new_rain) -value high
      grid .climpar_dlg.top.rf.rl -column 0 -row 0
      grid .climpar_dlg.top.rf.ra -column 1 -row 0
      grid .climpar_dlg.top.rf.rh -column 2 -row 0

      # Temperature radio buttons
      label .climpar_dlg.top.tt -text "Temperature:" -justify right
      frame .climpar_dlg.top.tf
      radiobutton .climpar_dlg.top.tf.tl -text "Low" \
         -variable g(climpar_new_temp) -value low
      radiobutton .climpar_dlg.top.tf.ta -text "Average" \
         -variable g(climpar_new_temp) -value avg
      radiobutton .climpar_dlg.top.tf.th -text "High" \
         -variable g(climpar_new_temp) -value high
      grid .climpar_dlg.top.tf.tl -column 0 -row 0
      grid .climpar_dlg.top.tf.ta -column 1 -row 0
      grid .climpar_dlg.top.tf.th -column 2 -row 0

      # Season
      label .climpar_dlg.top.sl -text "Display season:" -justify right
      frame .climpar_dlg.top.sf
      radiobutton .climpar_dlg.top.sf.ar -text "Average" \
         -variable g(climpar_new_seasel) -value avg \
         -command { .climpar_dlg.top.sf.ss configure -state disabled }
      radiobutton .climpar_dlg.top.sf.nr -text "Single" \
         -variable g(climpar_new_seasel) -value single \
         -command { .climpar_dlg.top.sf.ss configure -state normal }
      if { ! [ string compare $g(climpar_seasel) avg ] } {
         set scalestate disabled
      } else {
         set scalestate normal
      }
      scale .climpar_dlg.top.sf.ss -orient horizontal -label "" -showvalue 0 \
         -variable g(climpar_new_season) -to 3 -state $scalestate
      label .climpar_dlg.top.sf.sl -textvariable g(climpar_new_season)
      grid .climpar_dlg.top.sf.ar -column 0 -row 0
      grid .climpar_dlg.top.sf.nr -column 1 -row 0
      grid .climpar_dlg.top.sf.ss -column 2 -row 0
      grid .climpar_dlg.top.sf.sl -column 3 -row 0

      # Interpolation
      label .climpar_dlg.top.il -text "Interpolation:" -justify right
      checkbutton .climpar_dlg.top.ic -variable g(climpar_new_interpol)

      # Arrange upper frame
      grid .climpar_dlg.top.rt    -column 0 -row 0 -sticky e
      grid .climpar_dlg.top.rf    -column 1 -row 0 -sticky w
      grid .climpar_dlg.top.tt    -column 0 -row 1 -sticky e
      grid .climpar_dlg.top.tf    -column 1 -row 1 -sticky w
      grid .climpar_dlg.top.sl    -column 0 -row 2 -sticky e
      grid .climpar_dlg.top.sf    -column 1 -row 2 -sticky w
      grid .climpar_dlg.top.il    -column 0 -row 3 -sticky e
      grid .climpar_dlg.top.ic    -column 1 -row 3 -sticky w

      # Buttons and spacers
      label .climpar_dlg.btns.l
      label .climpar_dlg.btns.r
      button .climpar_dlg.btns.ok -text OK -command climpar_ok
      button .climpar_dlg.btns.can -text Cancel -command climpar_close
      grid .climpar_dlg.btns.l   -column 0 -row 0
      grid .climpar_dlg.btns.ok  -column 1 -row 0
      grid .climpar_dlg.btns.can -column 2 -row 0
      grid .climpar_dlg.btns.r   -column 3 -row 0

      # Window manager stuff
      wm title .climpar_dlg "Climate Parameters"
      wm protocol .climpar_dlg WM_DELETE_WINDOW climpar_close } }
