### Generate procs


# Batch function


proc gen_batch { } {
   util_busy . on
   # Minerals: abundance value difficulty military
   genmineral_store Copper 3 2 1 2
   genmineral_store Tin    3 1 1 2
   genmineral_store Iron   3 2 3 4
   genmineral_store Silver 2 3 2 1
   genmineral_store Gold   1 4 2 1
   util_busy . off }


# Mineral functions


proc genmineral_pack { f } {
   global g

   label $f.nl -text "Name:" -justify right
   entry $f.ne -textvariable g(genmineral_name)
   grid  $f.nl -column 0 -row 0 -sticky e
   grid  $f.ne -column 1 -row 0 -sticky w
   gen_scale $f "Abundance:"  1 genmineral_abundance
   gen_scale $f "Value:"      2 genmineral_value
   gen_scale $f "Difficulty:" 3 genmineral_difficulty
   gen_scale $f "Military:"   4 genmineral_military }



proc genmineral_apply { } {
   global g
   genmineral_store $g(genmineral_name) $g(genmineral_abundance) \
      $g(genmineral_value) $g(genmineral_difficulty)  $g(genmineral_military)
   set g(genmineral_name) "" }


proc genmineral_store { name abundance value difficulty military } {
   global g

   set params [ format "{TYPE mineral}" $abundance ]
   set params [ format "%s {ABUNDANCE %d}" $params $abundance ]
   set params [ format "%s {VALUE %d}" $params $value ]
   set params [ format "%s {DIFFICULTY %d}" $params $difficulty ]
   set params [ format "%s {MILITARY %d}" $params $military ]
   set seqno [ regMineral $name $abundance ]
   if { $g(region_showing) } {
      region_new 1 $name $seqno $params
   } else {
      region_load $name $seqno $params } }
   

proc genmineral_fill { params } {
   global g

   foreach l $params {
      set name  [ lindex $l 0 ]
      set value [ lindex $l 1 ]
      if { [ regexp -nocase abundance $name ] } {
         set g(genmineral_abundance) $value
      } elseif { [ regexp -nocase value $name ] } {
         set g(genmineral_value) $value
      } elseif { [ regexp -nocase difficulty $name ] } {
         set g(genmineral_difficulty) $value
      } elseif { [ regexp -nocase military $name ] } {
         set g(genmineral_military) $value } } }


# Shared functions


proc gen_show { force name params } {
   global g
   set type [ lindex [ lindex $params 0 ] 1 ]
   # if not forcing, and dialog not showing, give up
   if { (! $force) && (! $g(gen${type}_showing)) } { return }
   # Fill dialog with options
   set g(gen${type}_name) $name
   gen${type}_fill $params
   # Display or raise the dialog
   if { $g(gen${type}_showing) } {
      raise .genmineral_dlg
   } else {
      gen_create mineral } }


proc gen_scale { parent title row var } {
   # Title
   label $parent.l$row -text $title -justify right
   grid  $parent.l$row -column 0 -row $row -sticky e
   # Scalebar
   frame $parent.s$row
   grid  $parent.s$row -column 1 -row $row -sticky w
   scale $parent.s$row.s -orient horizontal -label "" -showvalue 0 \
      -variable g($var) -from 1 -to 5
   label $parent.s$row.l -textvariable g($var)
   grid  $parent.s$row.s -column 0 -row 0
   grid  $parent.s$row.l -column 1 -row 0 }


proc gen_close { type } {
   global g
   destroy .gen${type}_dlg
   set g(gen${type}_showing) 0 }


proc gen_ok { type } {
   gen${type}_apply
   gen_close gen$type }


proc gen_create { type } {
   global g

   if { $g(gen${type}_showing) } {
      return
   } elseif { ! $g(state_have_blob) } {
      util_errbox "Use File->New before generating ${type}s"
   } else {
      set g(gen${type}_showing) 1
      toplevel .gen${type}_dlg

      # Top level frame
      frame .gen${type}_dlg.top
      frame .gen${type}_dlg.btns
      grid  .gen${type}_dlg.top -column 0 -row 0
      grid  .gen${type}_dlg.btns -column 0 -row 1

      # Call pack function for internals
      gen${type}_pack .gen${type}_dlg.top

      # Buttons and spacers
      label .gen${type}_dlg.btns.l
      label .gen${type}_dlg.btns.r
      button .gen${type}_dlg.btns.ok -text OK \
          -command "gen_ok $type"
      button .gen${type}_dlg.btns.apply -text Apply \
         -command gen${type}_apply
      button .gen${type}_dlg.btns.close -text Close \
         -command "gen_close $type"
      grid .gen${type}_dlg.btns.l     -column 0 -row 0
      grid .gen${type}_dlg.btns.ok    -column 1 -row 0
      grid .gen${type}_dlg.btns.apply -column 2 -row 0
      grid .gen${type}_dlg.btns.close -column 3 -row 0
      grid .gen${type}_dlg.btns.r     -column 4 -row 0

      # Last minute stuff
      wm title .gen${type}_dlg "Generate Minerals"
      wm protocol .gen${type}_dlg WM_DELETE_WINDOW ${type}_close } }
