### Region procs


# Wrappers around callbacks


proc region_grow { type } {
   global g
   if { !$g(region_valid) } {
      util_errbox "Use Region->Manage before growing a region"
   } else {
      util_busy . on
      set n $g(region_selected)
      .main delete -tags lines
      regGrow $type
      eval [ regDraw [ expr $g(current_zoom) * 5 ] $g(region_seqno_$n) ]
      util_busy . off } }


proc region_refresh { } {
   global g
   if { $g(region_valid) } {
      set n $g(region_selected)
      .main delete -tags lines
      eval [ regDraw [ expr $g(current_zoom) * 5 ] $g(region_seqno_$n) ] } }


# Prepare for load
proc region_freeall { } {
   global g

   region_close
   set g(region_lastsel) -1
   set g(region_selected) -1
   set cr .region_dlg.top.c
   for { set i 0 } { $i < $g(region_highest) } { incr i } {
      regFree $g(region_seqno_$i)
      destroy $cr.r$i
      destroy $cr.e$i
      set g(region_params_$i) ""
      set g(region_name_$i) "" }
   set g(region_height) 2
   set g(region_highest) 0
   set g(region_valid) 0 }


# Load a region
proc region_load { name seqno params } {
   global g

   set n $g(region_highest)
   incr g(region_highest)
   set g(region_name_$n) $name
   set g(region_params_$n) $params
   set g(region_seqno_$n) $seqno }


proc region_clear { } {
   global g
   if { !$g(region_valid) } {
      util_errbox "Use Region->Manage before clearing a region"
   } else {
      util_busy . on
      set n $g(region_selected)
      .main delete -tags lines
      regClear
      # 6/10 huh? eval[regDraw[expr $g(current_zoom) * 5 ] $g(region_seqno_$n) ]
      util_busy . off } }


proc region_name { seqno } {
   global g
   for { set i 0 } { $i < $g(region_highest) } { incr i} {
      set n $g(region_seqno_$i)
      if { ! [ string compare $n $seqno ] } {
         return $g(region_name_$i) } } }


proc region_params { seqno } {
   global g
   for { set i 0 } { $i < $g(region_highest) } { incr i} {
      set n $g(region_seqno_$i)
      if { ! [ string compare $n $seqno ] } {
         return $g(region_params_$i) } } }


proc region_click { x y } {
   global g
   util_tipbox regclick "Use Region->Grow to add squares faster"
   eval [ regClick $x $y [ expr $g(current_zoom) * 5 ] ] }


proc region_select { n } {
   global g

   set cr .region_dlg.top.c
   .region_dlg.btns.delete configure -state normal
   .region_dlg.btns.show   configure -state normal
   set last $g(region_lastsel)
   if { ($last > -1) && ($last < $g(region_highest)) } {
      $cr.e$last configure -state disabled }
   $cr.e$n configure -state normal
   focus $cr.e$n
   set g(region_lastsel) $n
   set g(region_selected) $n
   # Draw
   util_busy . on
   .main delete -tags lines
   eval [ regDraw [ expr $g(current_zoom) * 5 ] $g(region_seqno_$n) ]
   set g(region_valid) 1
   region_show 0
   util_busy . off }


# Dialog button functions


proc region_make_row { i y } {
   set cr .region_dlg.top.c
   radiobutton $cr.r$i -variable g(region_selected) -value $i \
      -command "region_select {$i}"
   $cr create window 2 $y -window $cr.r$i -anchor nw -tags r$i
   entry $cr.e$i -state normal -textvariable g(region_name_$i) -width 30
   set x [expr 2 + [ winfo reqwidth $cr.r$i ] ]
   $cr create window $x $y -window $cr.e$i -anchor nw -tags e$i }


proc region_show { force } {
   global g

   set n $g(region_selected)
   set params $g(region_params_$n)
   if { $force && (! [ string compare $params "" ]) } {
      util_errbox "Only generated regions may be shown"
   } elseif { [ string compare $params "" ] } {
      gen_show $force $g(region_name_$n) $params } }


proc region_delete { } {
   global g
   incr g(region_highest) -1
   set n $g(region_selected)
   regFree $g(region_seqno_$n)
   # Move the names one line higher
   for { set i $n } { $i < $g(region_highest) } { incr i } {
      set next [ expr $i + 1 ]
      set g(region_name_$i) $g(region_name_$next)
      set g(region_params_$i) $g(region_params_$next)
      set g(region_seqno_$i) $g(region_seqno_$next) }
   # Delete the highest row
   set cr .region_dlg.top.c
   set y [ winfo reqheight $cr.e$i ]
   set g(region_height) [expr $g(region_height) - $y ]
   set width [ expr [ winfo reqwidth $cr.r$i ] + [ winfo reqwidth $cr.e$i ] ]
   $cr configure -scrollregion "0 0 $width $g(region_height)"
   $cr delete r$i
   $cr delete e$i
   destroy $cr.r$i
   destroy $cr.e$i
   set g(region_name_$i) ""
   set g(region_params_$i) ""
   # If none left, grey buttons, else draw new selection
   if { $g(region_highest) == 0 } {
      .region_dlg.btns.delete configure -state disabled
      .region_dlg.btns.show   configure -state disabled
      .main delete -tags lines
      set g(region_selected) -1
   } elseif { $g(region_selected) == $g(region_highest) } {
      region_select [ expr $g(region_highest) - 1 ]
   } else { region_select $g(region_selected) } }


proc region_new { generated name seqno params } {
   global g

   set cr .region_dlg.top.c
   set i $g(region_highest)
   incr g(region_highest)
   set y $g(region_height)
   region_make_row $i $y
   incr y [ winfo reqheight $cr.e$i ]
   set width [ expr [ winfo reqwidth $cr.r$i ] + [ winfo reqwidth $cr.e$i ] ]
   $cr configure -scrollregion "0 0 $width $y"
   set g(region_height) $y
   if { $generated } {
      set g(region_seqno_$i)  $seqno
      set g(region_name_$i)   $name
      set g(region_params_$i) $params
   } else {
      set g(region_seqno_$i) [ incr g(region_seqno) ]
      regInit $g(region_seqno_$i)
      set g(region_params_$i) ""
      util_tipbox regnew "Enter a name, then click to add squares" }
   region_select $i }


proc region_close { } {
   global g
   destroy .region_dlg
   .main delete -tags lines
   set g(region_valid) 0
   set g(region_showing) 0 }


# Top level proc for region manager


proc region_manage { } {
   global g

   if { $g(region_showing) } {
      return
   }
   if { ! $g(state_have_blob) } {
      util_errbox "Use File->New before managing regions"
   } elseif { ! [ string compare $g(current_facet) globe ] } {
      util_errbox "Cannot manage regions when globe displayed"
   } else {
      set g(region_showing) 1
      toplevel .region_dlg

      # Top level frame
      frame .region_dlg.top
      frame .region_dlg.btns
      grid .region_dlg.top -column 0 -row 0
      grid .region_dlg.btns -column 0 -row 1

      # Scrolled array of radio/entry pairs
      set cr .region_dlg.top.c
      canvas $cr -yscrollcommand ".region_dlg.top.sb set"
      scrollbar .region_dlg.top.sb -orient v -command "$cr yview"
      set y 2
      for { set i 0 } { $i < $g(region_highest) } { incr i } {
         region_make_row $i $y
         incr y [ winfo reqheight $cr.e$i ] }
      # Dummy radio/entry if none are displayed
      radiobutton $cr.r
      entry $cr.e -width 30
      set width [ expr [ winfo reqwidth $cr.r ] + [ winfo reqwidth $cr.e ] ]
      set height [ expr [ winfo reqheight $cr.e ] * 5 ]

      set g(region_height) $y
      $cr configure -scrollregion "0 0 $width $y" -height $height -width $width
      set g(region_lastsel) -1
      grid .region_dlg.top.c  -column 0 -row 0 -sticky ns
      grid .region_dlg.top.sb -column 1 -row 0 -sticky ns

      # Buttons and spacers
      label .region_dlg.btns.l
      label .region_dlg.btns.r
      button .region_dlg.btns.new    -text New    \
         -command { region_new 0 "" 0 "" }
      button .region_dlg.btns.delete -text Delete -command region_delete
      button .region_dlg.btns.show -text Show -command "region_show 1"
      if { $g(region_highest) == 0 || $g(region_selected) < 0 } {
         .region_dlg.btns.delete configure -state disabled
         .region_dlg.btns.show   configure -state disabled }
      button .region_dlg.btns.close  -text Close  -command region_close
      grid .region_dlg.btns.l      -column 0 -row 0
      grid .region_dlg.btns.new    -column 1 -row 0
      grid .region_dlg.btns.delete -column 2 -row 0
      grid .region_dlg.btns.show   -column 3 -row 0
      grid .region_dlg.btns.close  -column 4 -row 0
      grid .region_dlg.btns.r      -column 5 -row 0

      # Last minute stuff
      wm title .region_dlg "Manage Region"
      wm protocol .region_dlg WM_DELETE_WINDOW region_close
      set curr $g(region_selected)
      if { $curr > -1 } { region_select $curr }
      util_tipbox regmanage "Click New to add a new region" } }
