### View details dialog


proc videt_click { x y } {
   global g

   if { $g(videt_showing) } {
      set ret [ wbClick $x $y ]

      # Easy strings
      set g(videt_posn)     [ format "%.0f, %.0f" $x $y ]
      set g(videt_altitude) [ lindex $ret 0 ]
      set g(videt_climate)  [ lindex $ret 1 ]

      # Seasonal climate values
      set col [ .videt_dlg.top cget -bg ]
      set cols [ lindex $ret 2 ]
      for { set i 0 } { $i < 4 } { incr i } {
         if { $g(state_clim_valid) } { set col [ lindex $cols $i ] }
         .videt_dlg.top.sv$i configure -bg $col }

      # Temperature values
      set temps [ lindex $ret 3 ]
      for { set i 0 } { $i < 4 } { incr i } {
         set g(videt_temp_$i) [ lindex $temps $i ] } } }


# AOT polling method for keeping this dialog on top
proc videt_on_top { } {
   global g
   if { $g(videt_showing) } {
      raise .videt_dlg
      after 1000 videt_on_top } }


proc videt_close { } {
   global g

   destroy .videt_dlg
   set g(videt_showing) 0 }


proc view_details { } {
   global g

   if { $g(videt_showing) } {
      return 
   }
   if { ! $g(state_have_blob) } {
      util_errbox "Use File->New before viewing details"
   } elseif { ! [ string compare $g(current_facet) globe ] } {
      util_errbox "May not view details on globe"
   } else {

      set g(videt_showing) 1
      set g(videt_posn) "---"
      set g(videt_altitude) "---"
      set g(videt_climate) "---"
      for { set i 0 } { $i < 4 } { incr i } { set g(videt_temp_$i) "-" }
      toplevel .videt_dlg

      # Top level frame
      frame .videt_dlg.top
      frame .videt_dlg.btns
      grid .videt_dlg.top -column 0 -row 0
      grid .videt_dlg.btns -column 0 -row 1

      # Position, altitude
      label .videt_dlg.top.pl -text "Position:" -justify right
      label .videt_dlg.top.pv -textvariable g(videt_posn) -justify left
      label .videt_dlg.top.al -text "Altitude:" -justify right
      label .videt_dlg.top.av -textvariable g(videt_altitude) -justify left
      grid .videt_dlg.top.pl -column 0 -row 0 -sticky e
      grid .videt_dlg.top.pv -column 1 -row 0 -sticky w -columnspan 4
      grid .videt_dlg.top.al -column 0 -row 1 -sticky e
      grid .videt_dlg.top.av -column 1 -row 1 -sticky w -columnspan 4

      # Average climate and color block
      label .videt_dlg.top.cl -text "Climate:" -justify right
      label .videt_dlg.top.cv -textvariable g(videt_climate) -justify left
      grid .videt_dlg.top.cl -column 0 -row 2 -sticky e
      grid .videt_dlg.top.cv -column 1 -row 2 -sticky w -columnspan 4

      # Climate and temperature table
      label .videt_dlg.top.tl -text "Temperature:" -justify right
      label .videt_dlg.top.sl -text "Seasons:" -justify right
      grid .videt_dlg.top.tl -column 0 -row 3 -sticky e
      grid .videt_dlg.top.sl -column 0 -row 4 -sticky e
      for { set i 0 } { $i < 4 } { incr i } {
         label .videt_dlg.top.tv$i -textvariable g(videt_temp_$i) \
            -justify right -width 3
         label .videt_dlg.top.sv$i -width 3 -borderwidth 1 -relief groove
         grid .videt_dlg.top.tv$i -column [ expr $i + 1 ] -row 3 -sticky w
         grid .videt_dlg.top.sv$i -column [ expr $i + 1 ] -row 4 -sticky w }

      # Buttons and spacers
      label .videt_dlg.btns.l
      label .videt_dlg.btns.r
      button .videt_dlg.btns.close -text Close -command videt_close
      grid .videt_dlg.btns.l     -column 0 -row 0
      grid .videt_dlg.btns.close -column 1 -row 0
      grid .videt_dlg.btns.r     -column 2 -row 0

      # Window manager stuff
      wm title .videt_dlg "View Details"
      videt_on_top
      # AOT doesn't work on PC bind .videt_dlg <Visibility> { raise .videt_dlg }
      wm protocol .videt_dlg WM_DELETE_WINDOW videt_close } }
